
// $Id: converter_iface.js,v 1.27 2009/12/05 00:20:23 bogdan Exp $

if (MCE!=undefined && MCE.applicationName=='Converter' && !MCE.finishedLoading) {

MCE.iface={
	// Used to initialize the custom conversion text
	// (typically set by this.triggerCustom())
	customConversion_text:false,

	conversionStart:function()
	{
		window.setCursor('wait');
	},

	conversionEnd:function()
	{
		window.setCursor('auto');
	},

	showLocation:function(loc)
	{
		window.setTimeout(function() {
			MCE.iface.browse(loc);
		}, 100);
	},

	browse:function(loc)
	{
		gBrowser.selectedTab = gBrowser.addTab(loc);
	},

	doWelcome:function()
	{
	  var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                      getService(Components.interfaces.nsIPrefService);
	  var ver=MCE.applicationVersion;
	  var decision=false;
	  prefs = prefs.getBranch("extensions.converter.");
	  // IMPORTANT! The order of the tests below is significant!
	  if (
	    (prefs.getPrefType('current_version')==prefs.PREF_INVALID) ||
	    (prefs.getCharPref('current_version')=='')
	  ) {
	    prefs.setCharPref('current_version',ver);
	    decision='install';
	  }
	  if (
	    (prefs.getPrefType('first_version')==prefs.PREF_INVALID) ||
	    (prefs.getCharPref('first_version')=='')
	  ) {
	    prefs.setCharPref('first_version',prefs.getCharPref('current_version'));
	  }
	  if (prefs.getCharPref('current_version')!=ver) {
	    prefs.setCharPref('current_version',ver);
	    decision='upgrade';
	  }
	  if (!decision) {
	    return false;
	  }
	  var fver=prefs.getCharPref('first_version');

	  // fresh install -- always show welcome page
	  if (decision=='install') {
	      this.showLocation("http://converter.mozdev.org/welcome.html?ver="+ver);
	      return true;
	  }

	  // upgrade

	  if (MCE.releaseType=='minor') {
	    // minor release -- never show new features
	    return false;
	  }

	  if (MCE.releaseType=='major') {
	    // major release -- always show new features
	    this.showLocation("http://converter.mozdev.org/whatsnew.html?ver="+ver+"&fver="+fver);
	    return true;
	  }

	  // regular release -- ask whether to show new features
	  if (
	    confirm(
	      "Congratulations!\n"+
	      "-------------------------------------\n"+
	      "\n"+
	      "You have successfully upgraded the Converter extension!\n"+
	      "\n"+
	      "Would you like to find out what's new?"
	    )
	  ) {
	    this.showLocation("http://converter.mozdev.org/whatsnew.html?ver="+ver+"&fver="+fver);
	    return true;
	  }
	  return false;
	},

	getCBody:function()
	{
	  var cBodyT=content.document.getElementsByTagName("HTML");
	  if (cBodyT.length) {
	    return cBodyT[0];
	  }
	  throw "Converter: failed finding the top-level HTML element!";
	  return false;
	},

	setNewPage:function()
	{
	  var cBody=this.getCBody();
	  if (cBody) {
	    cBody.setAttribute("converter_extension_converted",false);
	    return true;
	  }
	},

	setOldPage:function()
	{
	  var cBody=this.getCBody();
	  if (cBody) {
	    cBody.setAttribute("converter_extension_converted",true);
	    return true;
	  }
	},

	isNewPage:function()
	{
	  var cBody=this.getCBody();
	  if (cBody) {
	    return (cBody.getAttribute("converter_extension_converted")!="true");
	  }
	  // This should be meaningless, as far as I can tell;
	  // throw exception and don't convert.
	  throw "Unexpected condition!";
	  return false;
	},

	initControls:function()
	{
	  var statIcon=document.getElementById('converter_status');
	  if (statIcon) {
	    statIcon.hidden = !MCE.prefs.getPref('pref_fullpage_icon');
	  }
	},

	init:function()
	{
	  // Welcome first ----------------------------------------------------
	  MCE.iface.doWelcome();

	  // Now the proper stuff ---------------------------------------------
          var tmpElement=document.getElementById("contentAreaContextMenu");
          if (tmpElement)
            tmpElement.addEventListener("popupshowing",MCE.iface.onPopup,false);
	  MCE.iface.initControls();
	  var statIcon=document.getElementById('converter_status');
	  if (statIcon) {
	    statIcon.addEventListener("popupshowing",MCE.iface.statusPopupShowing,false);
	  }
	},

	/**
	* This function is executed when the popup menu pops up.
	* It just triggers MCE.core.doConversion() and, depending on the
	* result, shows the conversion result in the popup menu.
	*/
	onPopup:function()
	{
	  var item = document.getElementById("context_converterselect");

	  // No selection -- show or hide "Convert entire page" based on preferences
	  if (!gContextMenu.isTextSelected){
	    if (
	      !MCE.prefs.getPref('pref_fullpage_menu')
	    ) {
	      item.hidden=true;
	      return true;
	    }
	    item.hidden = false;
	    if (MCE.iface.isNewPage()) {
              item.setAttribute("label", 'Convert the entire page');
	    } else {
	      item.setAttribute("label", 'Restore page');
	    }
	    return true;
	  }

	  // Selection
	  /*
	    We need to address a combination of situations here:
	    1. pref_selection_menu -- ON/OFF
	    2. pref_custom_convert_selection -- ON/OFF
	    3. conversion available -- YES/NO

	    (3) only needs to be triggered if (1)
	  */
	  var visible;
	  var label;
	  var sel=getBrowserSelection();

	  if (!MCE.prefs.getPref('pref_selection_menu')) {
	    label='';
	  } else {
	    var cr=MCE.core.doConversion(getBrowserSelection(),false);
	    if (!cr || cr.inhibit) {
	      label='';
	      if (MCE.prefs.getPref("pref_default_unit").length) {
	        var selectedText=getBrowserSelection();
	        var re=/[0-9.,]+/;
	        var match=re.exec(selectedText);
	        if (match) {
	          cr=MCE.core.doConversion(match[0]+' '+MCE.prefs.getPref("pref_default_unit"));
	          if (cr && !cr.inhibit) {
	            label = cr.inValue + " " + cr.inUnit + " = " + cr.outCustom;
	          }
	        }
	      }
	    } else {
	      label = cr.inValue + " " + cr.inUnit + " = " + cr.outCustom;
	    }
	  }
	  if (MCE.prefs.getPref('pref_custom_convert_selection')) {
	    if (!label) {
	      if (sel.length>18) {
	        sel=sel.substring(0,15)+"...";
	      }
	      label='Custom convert "'+sel+'"';
	    } else {
	      label+='...';
	    }
	  }
	  if (!label) {
	    item.hidden=true;
	    return false;
	  }
	  item.hidden = false;
	  item.setAttribute("label", label);
	  return true;
	},

	fullPageAction:function()
	{
	  if (this.isNewPage()) {
	    MCE.core.convertPage();
	  } else {
	    MCE.core.restorePage();
	  }
	},

	/**
	* This function is called when the user clicks on the converter entry
	* in the popup.
	*/
	onConvert:function()
	{
	  if (!gContextMenu.isTextSelected) {
	    this.fullPageAction();
	    return true;
	  }

	  // Text is selected
	  if (MCE.prefs.getPref('pref_custom_convert_selection')) {
	    this.triggerCustom(getBrowserSelection());
	  }
	  return true;
	},

	statusClicked:function(evt)
	{
	  /*
	  // Unfortunately icon switching doesn't work well with tabs, to my knowledge,
	  // so we'll have to keep a single icon throughout. See linkification.
	  var cvStatus = document.getElementById("converter-status-hbox");
	  cvStatus.src = 'chrome://converter/skin/cv_stat_on.png';
	  alert("Clicked!");
	  */
	  if (evt.button != 0)
	  {
	    return true;
	  }
	  this.fullPageFromStatus();
	},

	fullPageFromStatus:function()
	{
	  this.fullPageAction();
	},

	triggerCustom:function(content)
	{
	  this.customConversion_text=content;
	  this.customConversionPopup();
	  
	},

	customConversionPopup:function()
	{
	  var w=window.openDialog("chrome://converter/content/custom_conversion.xul",
	    "Converter_custom", "centerscreen"
	  );
	  w.focus();
	},

	openPrefsWindow:function()
	{
	  var w=window.openDialog("chrome://converter/content/converterPrefDialog.xul",
	    "Converter_preferences", "centerscreen"
	  );
	  w.focus();
	},

	custom_conversion_keyup:function(event)
	{
		if (event.keyCode==27) {
			this.custom_conversion_close();
		}
		if (event.keyCode==13 && event.ctrlKey) {
			this.custom_conversion_convert();
		}
	},

	custom_conversion_convert:function()
	{
		if (window.document.getElementById('strict').checked) {
			var cr=opener.MCE.core.doConversion(window.document.getElementById('beef').value,false);
			if (cr.inUnit==undefined || cr.inhibit) {
				window.document.getElementById('in_unit').value='n/a';
			} else {
				window.document.getElementById('in_unit').value=cr.inUnit;
			}
			if (cr.inValue==undefined || cr.inhibit) {
				window.document.getElementById('in_value').value='n/a';
			} else {
				window.document.getElementById('in_value').value=cr.inValue;
			}
			if (cr.outCustom==undefined || cr.inhibit) {
				window.document.getElementById('hamburger').value='';
			} else {
				window.document.getElementById('hamburger').value=cr.outCustom;
			}
		} else {
			window.document.getElementById('hamburger').value=opener.MCE.core.convertText(window.document.getElementById('beef').value);
		}
		window.document.getElementById('beef').focus();
		window.document.getElementById('beef').select();
	},

	custom_conversion_close:function()
	{
		MCE.prefs.setPref('pref_custom_single',window.document.getElementById('strict').checked);
		window.close();
	},

	custom_conversion_open:function()
	{
		window.document.getElementById('strict').checked=MCE.prefs.getPref('pref_custom_single');
		window.document.getElementById('beef').focus();
		window.addEventListener('keyup',function(e) {
			MCE.iface.custom_conversion_keyup(e);
		},false);
		this.custom_conversion_switch();
		if (opener.MCE.iface.customConversion_text) {
			window.document.getElementById('beef').value=opener.MCE.iface.customConversion_text;
			opener.MCE.iface.customConversion_text=false;
			this.custom_conversion_convert();
		}
	},

	custom_conversion_switch:function()
	{
		window.document.getElementById('in_value_box').hidden=
		window.document.getElementById('in_unit_box').hidden=
			!window.document.getElementById('strict').checked;
	},

	log_console: Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService),

	log: function(message) {
	  this.log_console.logStringMessage('MCE: '+message);
	},

	statusPopupShowing:function()
	{
	  if (MCE.iface.isNewPage()) {
	    document.getElementById("converter-status-convertPage").label='Convert the entire page';
	  } else {
	    document.getElementById("converter-status-convertPage").label='Restore page';
	  }
	},
	
	getDocument:function()
	{
	  return gBrowser.contentWindow.document;
	},

	getAllDocuments:function()
	{
	  var docs=[];
	  if (gBrowser.contentWindow.frames.length>0) {
	    for(var i=0;i<gBrowser.contentWindow.frames.length;i++) {
	      docs.push(gBrowser.contentWindow.frames[i].document);
	    }
	  }
	  docs.push(gBrowser.contentWindow.document);
	  return docs;
	}

}

window.addEventListener("load",MCE.iface.init,false);

}
