if (MCE!=undefined && MCE.applicationName=='Converter' && !MCE.finishedLoading) {
MCE.prefs.gui={
	currencyControlsInitialized: false,
	
	updateInterface:function()
	{
		// Update warnings/info
		var ib=document.getElementById('infobox');
		while(ib.firstChild!=undefined) {
			ib.removeChild(ib.firstChild);
		}
		var info=new Array();
		document.getElementById('pref_custom_convert_selection').disabled=!document.getElementById('pref_selection_menu').checked;
		if (
			document.getElementById('pref_only_show_converted').checked || 
			document.getElementById("pref_replace_original").checked
		) {
			info.push({
				type:"WARNING",
				desc:"You have chosen to disable some of the Converter's default provisions "+
				"meant to ensure visual confirmation for conversions. Please be advised the Converter has "+
				"known limitations regarding the number of formats it is able to process, and disabling any "+
				"of the default provisions will result in ambiguity in specific cases."
			});
		}
		if (
			document.getElementById('pref_currency_enabled').checked &&
			!document.getElementById('pref_myCurrency').value
		) {
			info.push({
				type:'WARNING',
				desc:"You have enabled currency conversions but you haven't selected a preferred currency. "+
				"Please choose your currency if you want to use this functionality."
			});
		}
		if (document.getElementById('pref_thou_sep').value==document.getElementById('pref_dec_sep').value) {
			info.push({
				type:"WARNING",
				desc:"You have selected the same thousands separator and decimal separator; "+
				"this will result in ambiguous values."
			});
		}
		info.push({
			type:"INFO",
			desc:"Previous conversions will not be affected by changes in the preferences."
		});

		var contextualEnabled=document.getElementById('pref_selection_menu').checked;
		document.getElementById('label_default_unit').disabled=!contextualEnabled;
		document.getElementById('pref_default_unit').disabled=!contextualEnabled;
		
		var i;
		var aLabel;
		var aDesc;
		for(i=0;i<info.length;i++) {
			aLabel=document.createElement("description");
			aDesc=document.createTextNode('* '+info[i].type+': '+info[i].desc);
			aLabel.appendChild(aDesc);
			if (info[i].type=='WARNING') {
				aLabel.style.color='#ff0000';
			} else if (info[i].type=='SUGGESTION') {
				aLabel.style.color='#009000';
			}
			aLabel.style.fontSize='90%';
			ib.appendChild(aLabel);
		}
		
		document.getElementById('pref_in_fract').disabled=(
			document.getElementById('pref_metric').value==1 &&
			document.getElementById('pref_one_way').checked
		);
	},
	
	prefsOnLoad:function()
	{
		document.getElementById("pref_24h").value=MCE.prefs.getPref('pref_24h')?'1':'0';
		document.getElementById("pref_fullpage_icon").checked=MCE.prefs.getPref('pref_fullpage_icon');
		document.getElementById("pref_fullpage_menu").checked=MCE.prefs.getPref('pref_fullpage_menu');
		document.getElementById("pref_selection_menu").checked=MCE.prefs.getPref('pref_selection_menu');
		document.getElementById("pref_metric").value=MCE.prefs.getPref('pref_metric')?'1':'0';
		document.getElementById("pref_celsius").value=MCE.prefs.getPref('pref_celsius')?'1':'0';
		document.getElementById("pref_in_fract").value=MCE.prefs.getPref('pref_in_fract')?'1':'0';
		document.getElementById("pref_custom_convert_selection").checked=MCE.prefs.getPref('pref_custom_convert_selection');
		document.getElementById("pref_thou_sep").value=MCE.prefs.getPref('pref_thou_sep');
		document.getElementById("pref_dec_sep").value=MCE.prefs.getPref('pref_dec_sep');
		document.getElementById("pref_one_way").checked=MCE.prefs.getPref('pref_one_way');
		document.getElementById("pref_only_show_converted").checked=MCE.prefs.getPref('pref_only_show_converted');
		document.getElementById("pref_replace_original").checked=MCE.prefs.getPref('pref_replace_original');

		document.getElementById("pref_default_unit").value=MCE.prefs.getPref('pref_default_unit');

		// Currency
		document.getElementById("pref_currency_enabled").checked=MCE.prefs.getPref('pref_currency_enabled');
		this.initCurrencyControls();
		
                document.addEventListener('keyup',MCE.prefs.gui.keyPressed,false);

		return true;
	},
	
	prefsOnResize:function()
	{
		this.updateInterface();
	},

	keyPressed:function(e)
	{
		if (e.keyCode==27) {
			MCE.prefs.close_cancel();
		}
		if (e.keyCode==13) {
			MCE.prefs.close_ok();
		}
	},

	initCurrencyControls:function()
	{
		var list=document.getElementById("pref_myCurrency");
		var enabled=document.getElementById("pref_currency_enabled").checked;
		document.getElementById("pref_myCurrencyLabel").disabled=!enabled;
		list.disabled=!enabled;

		if (this.currencyControlsInitialized) {
			if (list.value && list.getItemAtIndex(0).value=='') {
				list.removeItemAt(0);
			}
			this.updateInterface();
			return true;
		}

		this.currencyControlsInitialized=true;

		var listIndex=MCE.util.inArray(MCE.prefs.getPref('pref_myCurrency'),MCE.currency.currencies);
		if (listIndex==-1) {
			listIndex=0;
			list.appendItem("(select your currency)",'');
		}
		var cc; // Currency code
		var cn; // Currency name
		for(var i=0;i<MCE.currency.currencies.length;i++) {
			cc=MCE.currency.currencies[i];
			if (cc in MCE.currency.currency_names) {
				cn=' ('+MCE.currency.currency_names[cc]+')';
			} else {
				cn='';
			}
			list.appendItem(
				cc, /* label */
				cc, /* value */
				cn /* description */
			);	
		}
		list.selectedIndex=listIndex;
		return true;
	},

	close_ok:function()
	{
		if (
			document.getElementById("pref_currency_enabled").checked &&
			!document.getElementById("pref_myCurrency").value
		) {
			alert(
				"If you want to use the currency conversion features\n"+
				"you have to select the target currency."
			);
			return false;
		}
		MCE.prefs.setPref("pref_24h",document.getElementById("pref_24h").value=="1");
		MCE.prefs.setPref("pref_fullpage_icon",document.getElementById("pref_fullpage_icon").checked);
		MCE.prefs.setPref("pref_fullpage_menu",document.getElementById("pref_fullpage_menu").checked);
		MCE.prefs.setPref("pref_selection_menu",document.getElementById("pref_selection_menu").checked);
		MCE.prefs.setPref("pref_metric",document.getElementById("pref_metric").value=="1");
		MCE.prefs.setPref("pref_celsius",document.getElementById("pref_celsius").value=="1");
		MCE.prefs.setPref("pref_in_fract",document.getElementById("pref_in_fract").value=="1");
		MCE.prefs.setPref("pref_currency_enabled",document.getElementById("pref_currency_enabled").checked);
		MCE.prefs.setPref("pref_myCurrency",document.getElementById("pref_myCurrency").value);
		MCE.prefs.setPref("pref_custom_convert_selection",document.getElementById("pref_custom_convert_selection").checked);
		MCE.prefs.setPref("pref_thou_sep",document.getElementById("pref_thou_sep").value);
		MCE.prefs.setPref("pref_dec_sep",document.getElementById("pref_dec_sep").value);
		MCE.prefs.setPref("pref_one_way",document.getElementById("pref_one_way").checked);
		MCE.prefs.setPref("pref_only_show_converted",document.getElementById("pref_only_show_converted").checked);
		MCE.prefs.setPref("pref_replace_original",document.getElementById("pref_replace_original").checked);
		MCE.prefs.setPref("pref_default_unit",document.getElementById("pref_default_unit").value);
		this.prefActions();
		window.close();
	},

	close_cancel:function()
	{
		if (
			MCE.prefs.getPref("pref_currency_enabled") &&
			!MCE.prefs.getPref("pref_myCurrency")
		) {
			document.getElementById("pref_currency_enabled").checked=false;
			MCE.prefs.setPref("pref_currency_enabled",false);
			this.initCurrencyControls();
			
			alert(
				"Currency conversions have been disabled.\n"+
				"You can enable them at any time in the options dialog."
			);
		}
		/*
			Sometimes this is opened as modal. In that case, event listeners seem to
			be inherited by the opener. Failing to remove them causes the opener
			to misbehave (i.e. events still get captured by the modal window's listeners
			even after it gets closed, although that happens in a sick and twisted way
			which doesn't allow the listeners to actually perform; probably a bad case
			of good practice plus security concerns mangling this up).
		*/
		document.removeEventListener('keyup',MCE.prefs.gui.keyPressed,false);
		window.close();
	},

	prefActions:function()
	{
		var myWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
		myWindow.MCE.iface.initControls();
		return true;
	}
}

}
