
// $Id: converter_regression.js,v 1.3 2009/12/05 00:19:57 bogdan Exp $

if (MCE!=undefined && MCE.applicationName=='Converter' && !MCE.finishedLoading) {

MCE.regression={
	color_passed:'#AAFFAA',
	color_failed:'#FFAAAA',
	
	getElementsByTagNTitle:function(tagName,title)
	{
		var elems=content.document.getElementsByTagName("td");
		var results=new Array();
		for(var i=0;i<elems.length;i++) {
			if (elems[i].title==title) {
				results.push(elems[i]);
			}
		}
		return results;
	},

	// mark this DOM node as PASSED
	regressionPass:function(node)
	{
		node.style.backgroundColor=this.color_passed;
		node.innerHTML='PASSED';
		node.style.fontWeight='bold';
		node.style.textAlign='center';
		return true;
	},
	
	// mark this DOM node as FAILED
	regressionFail:function(node,text)
	{
		node.style.backgroundColor=this.color_failed;
		node.innerHTML=text;
	},
	
	regressionTest:function()
	{
	  if (content.document.title!="Converter Regression Test Page {8B72860F-C5F8-4286-865E-D2C2DB98A9E6}") {
	    return false;
	  }

	  // Check version
	  var version_node=content.document.getElementById('intended_version');
	  if (version_node==undefined) {
	    // WTF?
	    return false;
	  }
	  if (version_node.title!=MCE.applicationVersion) {
	    // uh-oh, old one -- show warning
	    version_node.style.display='block';
	    version_node.title='';
	  }

	  var tests=this.getElementsByTagNTitle('td','converter_test');
	  var c_assertions=this.getElementsByTagNTitle('td','contextual_assertion');
	  var c_test=this.getElementsByTagNTitle('td','contextual_test');
	  var p_assertions=this.getElementsByTagNTitle('td','full_page_assertion');
	  var p_test=this.getElementsByTagNTitle('td','full_page_test');
	  var i=0;
	  var status_text='Some tests have failed:<br><ul>';
	  var status_result=true;
	  for(i=0;i<tests.length;i++) {
	    var test=tests[i].innerHTML;

	    // contextual conversion
	    var cr=MCE.core.doConversion(test,false);
	    c_test[i].style.color='#000000';
	    if (!cr) {
	      if (c_assertions[i].innerHTML=='[no match]') {
		    this.regressionPass(c_test[i]);
	      } else {
		    this.regressionFail(c_test[i],'[no match]');
		    status_result=false;
		    status_text+="<li>Test "+(i+1)+" has failed (contextual).</li>";
	      }
	    } else if (cr.inhibit) {
	      if (c_assertions[i].innerHTML=='[no conversion]') {
		    this.regressionPass(c_test[i]);
	      } else {
		    this.regressionFail(c_test[i],'[no conversion]');
		    status_result=false;
		    status_text+="<li>Test "+(i+1)+" has failed (contextual).</li>";
	      }
	    } else {
	      if (cr.inUnit.length) {
	        var contextual=cr.inValue + " " + cr.inUnit + " = " + cr.outCustom;
	      } else {
	        var contextual=cr.inValue + " = " + cr.outCustom;
	      }
	      if (contextual==c_assertions[i].innerHTML) {
		    this.regressionPass(c_test[i]);
	      } else {
		    this.regressionFail(c_test[i],contextual);
		    status_result=false;
		    status_text+="<li>Test "+(i+1)+" has failed (contextual).</li>";
	      }
	    }

	    // full page conversion
	    var full_page=MCE.core.convertText(test);
	    p_test[i].style.color='#000000';
	    if (full_page==p_assertions[i].innerHTML) {
		  this.regressionPass(p_test[i]);
	    } else {
		  this.regressionFail(p_test[i],full_page);
	      status_result=false;
	      status_text+="<li>Test "+(i+1)+" has failed (full page).</li>";
	    }
	  }

	  var stat_p=content.document.getElementById('crt_status_p');
	  var stat_span=content.document.getElementById('crt_status_span');
	  if (status_result) {
	    stat_p.style.backgroundColor=this.color_passed;
	    stat_span.innerHTML='All tests passed successfully.';
	  } else {
	    stat_p.style.backgroundColor=this.color_failed;
	    stat_span.innerHTML=status_text+"</ul>";
	  }
	  
	  return true;
	}

}

}
